// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-analytics-dtos.proto

package com.accelfin.server.demo.analytics.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto}
 */
public  final class FxAlertsReportSymbolPriceDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto)
    FxAlertsReportSymbolPriceDtoOrBuilder {
  // Use FxAlertsReportSymbolPriceDto.newBuilder() to construct.
  private FxAlertsReportSymbolPriceDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private FxAlertsReportSymbolPriceDto() {
    symbol_ = "";
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private FxAlertsReportSymbolPriceDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (time_ != null) {
              subBuilder = time_.toBuilder();
            }
            time_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(time_);
              time_ = subBuilder.buildPartial();
            }

            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            symbol_ = s;
            break;
          }
          case 26: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (bid_ != null) {
              subBuilder = bid_.toBuilder();
            }
            bid_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(bid_);
              bid_ = subBuilder.buildPartial();
            }

            break;
          }
          case 34: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (ask_ != null) {
              subBuilder = ask_.toBuilder();
            }
            ask_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(ask_);
              ask_ = subBuilder.buildPartial();
            }

            break;
          }
          case 42: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (mid_ != null) {
              subBuilder = mid_.toBuilder();
            }
            mid_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(mid_);
              mid_ = subBuilder.buildPartial();
            }

            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportSymbolPriceDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportSymbolPriceDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.class, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder.class);
  }

  public static final int TIME_FIELD_NUMBER = 1;
  private com.accelfin.server.messaging.dtos.TimestampDto time_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
   */
  public boolean hasTime() {
    return time_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getTime() {
    return time_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : time_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getTimeOrBuilder() {
    return getTime();
  }

  public static final int SYMBOL_FIELD_NUMBER = 2;
  private volatile java.lang.Object symbol_;
  /**
   * <code>optional string symbol = 2;</code>
   */
  public java.lang.String getSymbol() {
    java.lang.Object ref = symbol_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      symbol_ = s;
      return s;
    }
  }
  /**
   * <code>optional string symbol = 2;</code>
   */
  public com.google.protobuf.ByteString
      getSymbolBytes() {
    java.lang.Object ref = symbol_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      symbol_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int BID_FIELD_NUMBER = 3;
  private com.accelfin.server.messaging.dtos.DecimalDto bid_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
   */
  public boolean hasBid() {
    return bid_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getBid() {
    return bid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : bid_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getBidOrBuilder() {
    return getBid();
  }

  public static final int ASK_FIELD_NUMBER = 4;
  private com.accelfin.server.messaging.dtos.DecimalDto ask_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
   */
  public boolean hasAsk() {
    return ask_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getAsk() {
    return ask_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : ask_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getAskOrBuilder() {
    return getAsk();
  }

  public static final int MID_FIELD_NUMBER = 5;
  private com.accelfin.server.messaging.dtos.DecimalDto mid_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
   */
  public boolean hasMid() {
    return mid_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getMid() {
    return mid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : mid_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getMidOrBuilder() {
    return getMid();
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (time_ != null) {
      output.writeMessage(1, getTime());
    }
    if (!getSymbolBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 2, symbol_);
    }
    if (bid_ != null) {
      output.writeMessage(3, getBid());
    }
    if (ask_ != null) {
      output.writeMessage(4, getAsk());
    }
    if (mid_ != null) {
      output.writeMessage(5, getMid());
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (time_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getTime());
    }
    if (!getSymbolBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(2, symbol_);
    }
    if (bid_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getBid());
    }
    if (ask_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getAsk());
    }
    if (mid_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getMid());
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto)
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportSymbolPriceDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportSymbolPriceDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.class, com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      if (timeBuilder_ == null) {
        time_ = null;
      } else {
        time_ = null;
        timeBuilder_ = null;
      }
      symbol_ = "";

      if (bidBuilder_ == null) {
        bid_ = null;
      } else {
        bid_ = null;
        bidBuilder_ = null;
      }
      if (askBuilder_ == null) {
        ask_ = null;
      } else {
        ask_ = null;
        askBuilder_ = null;
      }
      if (midBuilder_ == null) {
        mid_ = null;
      } else {
        mid_ = null;
        midBuilder_ = null;
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertsReportSymbolPriceDto_descriptor;
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto build() {
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto buildPartial() {
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto result = new com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto(this);
      if (timeBuilder_ == null) {
        result.time_ = time_;
      } else {
        result.time_ = timeBuilder_.build();
      }
      result.symbol_ = symbol_;
      if (bidBuilder_ == null) {
        result.bid_ = bid_;
      } else {
        result.bid_ = bidBuilder_.build();
      }
      if (askBuilder_ == null) {
        result.ask_ = ask_;
      } else {
        result.ask_ = askBuilder_.build();
      }
      if (midBuilder_ == null) {
        result.mid_ = mid_;
      } else {
        result.mid_ = midBuilder_.build();
      }
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto) {
        return mergeFrom((com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto other) {
      if (other == com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto.getDefaultInstance()) return this;
      if (other.hasTime()) {
        mergeTime(other.getTime());
      }
      if (!other.getSymbol().isEmpty()) {
        symbol_ = other.symbol_;
        onChanged();
      }
      if (other.hasBid()) {
        mergeBid(other.getBid());
      }
      if (other.hasAsk()) {
        mergeAsk(other.getAsk());
      }
      if (other.hasMid()) {
        mergeMid(other.getMid());
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto time_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> timeBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public boolean hasTime() {
      return timeBuilder_ != null || time_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getTime() {
      if (timeBuilder_ == null) {
        return time_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : time_;
      } else {
        return timeBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public Builder setTime(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (timeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        time_ = value;
        onChanged();
      } else {
        timeBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public Builder setTime(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (timeBuilder_ == null) {
        time_ = builderForValue.build();
        onChanged();
      } else {
        timeBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public Builder mergeTime(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (timeBuilder_ == null) {
        if (time_ != null) {
          time_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(time_).mergeFrom(value).buildPartial();
        } else {
          time_ = value;
        }
        onChanged();
      } else {
        timeBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public Builder clearTime() {
      if (timeBuilder_ == null) {
        time_ = null;
        onChanged();
      } else {
        time_ = null;
        timeBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getTimeBuilder() {
      
      onChanged();
      return getTimeFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getTimeOrBuilder() {
      if (timeBuilder_ != null) {
        return timeBuilder_.getMessageOrBuilder();
      } else {
        return time_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : time_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto time = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getTimeFieldBuilder() {
      if (timeBuilder_ == null) {
        timeBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getTime(),
                getParentForChildren(),
                isClean());
        time_ = null;
      }
      return timeBuilder_;
    }

    private java.lang.Object symbol_ = "";
    /**
     * <code>optional string symbol = 2;</code>
     */
    public java.lang.String getSymbol() {
      java.lang.Object ref = symbol_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        symbol_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolBytes() {
      java.lang.Object ref = symbol_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        symbol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public Builder setSymbol(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      symbol_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public Builder clearSymbol() {
      
      symbol_ = getDefaultInstance().getSymbol();
      onChanged();
      return this;
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public Builder setSymbolBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      symbol_ = value;
      onChanged();
      return this;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto bid_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> bidBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public boolean hasBid() {
      return bidBuilder_ != null || bid_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getBid() {
      if (bidBuilder_ == null) {
        return bid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : bid_;
      } else {
        return bidBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public Builder setBid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (bidBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        bid_ = value;
        onChanged();
      } else {
        bidBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public Builder setBid(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (bidBuilder_ == null) {
        bid_ = builderForValue.build();
        onChanged();
      } else {
        bidBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public Builder mergeBid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (bidBuilder_ == null) {
        if (bid_ != null) {
          bid_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(bid_).mergeFrom(value).buildPartial();
        } else {
          bid_ = value;
        }
        onChanged();
      } else {
        bidBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public Builder clearBid() {
      if (bidBuilder_ == null) {
        bid_ = null;
        onChanged();
      } else {
        bid_ = null;
        bidBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getBidBuilder() {
      
      onChanged();
      return getBidFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getBidOrBuilder() {
      if (bidBuilder_ != null) {
        return bidBuilder_.getMessageOrBuilder();
      } else {
        return bid_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : bid_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getBidFieldBuilder() {
      if (bidBuilder_ == null) {
        bidBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getBid(),
                getParentForChildren(),
                isClean());
        bid_ = null;
      }
      return bidBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto ask_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> askBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public boolean hasAsk() {
      return askBuilder_ != null || ask_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getAsk() {
      if (askBuilder_ == null) {
        return ask_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : ask_;
      } else {
        return askBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public Builder setAsk(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (askBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ask_ = value;
        onChanged();
      } else {
        askBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public Builder setAsk(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (askBuilder_ == null) {
        ask_ = builderForValue.build();
        onChanged();
      } else {
        askBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public Builder mergeAsk(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (askBuilder_ == null) {
        if (ask_ != null) {
          ask_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(ask_).mergeFrom(value).buildPartial();
        } else {
          ask_ = value;
        }
        onChanged();
      } else {
        askBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public Builder clearAsk() {
      if (askBuilder_ == null) {
        ask_ = null;
        onChanged();
      } else {
        ask_ = null;
        askBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getAskBuilder() {
      
      onChanged();
      return getAskFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getAskOrBuilder() {
      if (askBuilder_ != null) {
        return askBuilder_.getMessageOrBuilder();
      } else {
        return ask_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : ask_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getAskFieldBuilder() {
      if (askBuilder_ == null) {
        askBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getAsk(),
                getParentForChildren(),
                isClean());
        ask_ = null;
      }
      return askBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto mid_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> midBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public boolean hasMid() {
      return midBuilder_ != null || mid_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getMid() {
      if (midBuilder_ == null) {
        return mid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : mid_;
      } else {
        return midBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public Builder setMid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (midBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        mid_ = value;
        onChanged();
      } else {
        midBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public Builder setMid(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (midBuilder_ == null) {
        mid_ = builderForValue.build();
        onChanged();
      } else {
        midBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public Builder mergeMid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (midBuilder_ == null) {
        if (mid_ != null) {
          mid_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(mid_).mergeFrom(value).buildPartial();
        } else {
          mid_ = value;
        }
        onChanged();
      } else {
        midBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public Builder clearMid() {
      if (midBuilder_ == null) {
        mid_ = null;
        onChanged();
      } else {
        mid_ = null;
        midBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getMidBuilder() {
      
      onChanged();
      return getMidFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getMidOrBuilder() {
      if (midBuilder_ != null) {
        return midBuilder_.getMessageOrBuilder();
      } else {
        return mid_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : mid_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getMidFieldBuilder() {
      if (midBuilder_ == null) {
        midBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getMid(),
                getParentForChildren(),
                isClean());
        mid_ = null;
      }
      return midBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto)
  private static final com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto();
  }

  public static com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<FxAlertsReportSymbolPriceDto>
      PARSER = new com.google.protobuf.AbstractParser<FxAlertsReportSymbolPriceDto>() {
    public FxAlertsReportSymbolPriceDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new FxAlertsReportSymbolPriceDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<FxAlertsReportSymbolPriceDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<FxAlertsReportSymbolPriceDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.analytics.dtos.FxAlertsReportSymbolPriceDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

